/*
 * project.c
 *
 *  Created on: Jan 8, 2023
 *      Author: bruce
 */

#include <string.h>
#include <stdint.h>
#include <stdio.h>
#include "project.h"
#include "player_actions.h"
#include "hw4.h"
#include "player_actions.h"

void project_run() {
	char buffer[80];
	char* cur = buffer;
	uint8_t state = STOPPED_STATE;

	help();
	for (;;) {
		if (state == PAUSED_STATE)
			pause_loop();
		char ch = read_and_print_char_nonblocking();
		if (!ch)
			continue;
		if (ch == '\r') {
			*cur = 0;
			handle_input(buffer, &state);
			cur = buffer;
			continue;
		}
		if (ch == 0x08 || ch == 0x7F) {
			if (cur <= buffer)
				continue;
			cur--;
			printf("\b \b");
			continue;
		}
		*cur++ = ch;
	}
}

void handle_input(char buffer[], uint8_t *state) {
	if (!strcmp(buffer, "HELP")) {
		help();
	}
	else if (!strcmp(buffer, "NEXT")) {
		next();
	}
	else if (!strcmp(buffer, "PLAY")) {
		play();
		*state = PLAYING_STATE;
	}
	else if (!strcmp(buffer, "PAUSE")) {
		pause();
		*state = PAUSED_STATE;
	}
	else if (!strcmp(buffer, "STOP")) {
		stop();
		*state = STOPPED_STATE;
	}
	else {
		printf("Unknown command \"%s\"\n\r", buffer);
	}
}
